/********************************** (C) COPYRIGHT *********************************
* File Name          : CH395.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395
**********************************************************************************/
/* ͷļ*/
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "../PUB/CH395INC.H"
#include "CH395.H"
#include "CH395FTPINC.H"
extern FTP ftp;			
/********************************************************************************/
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3                     
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"                                           
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"                                            
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.C"
#endif
/********************************************************************************/
/* ļ */
#include "../PUB/CH395CMD.C"
/*******************************************************************************/

/* ñ */
#define MybufLen  536                                               /* ch395ݵĻ󳤶 */
#define CH395_DEBG					1
UINT8  MyBuffer[2][MybufLen];                                       /* ݻ */
struct _SCOK_INF  ScokInf[2];                                       /* SocketϢ */
struct _CH395_SYS CH395Inf;                                         /* CH395Ϣ */
UINT8  PortTmp;                                                     /* ڸı˿ֵ */

/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                         /* ɹ */
    printf("Error: %02X\n", (UINT16)iError);                       /* ʾ */
    while ( 1 ) 
    {
        mDelaymS(200);
        mDelaymS(200);
    }
}

/*******************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/*******************************************************************************
* Function Name  : CH395ClientSocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : index
* Output         : None
* Return         : None
*******************************************************************************/
void CH395ClientSocketInitOpen(UINT8 index)
{
    UINT8 i;

    CH395SetSocketDesIP(index,ScokInf[index].IPAddr);                  /* socket ĿIPַ */         
    CH395SetSocketProtType(index,ScokInf[index].ProtoType);            /* socket Э */
    CH395SetSocketDesPort(index,ScokInf[index].DesPort);               /* socket ĿĶ˿ */
    CH395SetSocketSourPort(index,ScokInf[index].SourPort);             /* socket Դ˿ */
    i = CH395OpenSocket(index);                                        /* socket  */
    mStopIfError(i);                                                   /* Ƿɹ */
    i = CH395TCPConnect(index);                                        /* TCP */
    mStopIfError(i);                                                   /* Ƿɹ */
}

/********************************************************************************
* Function Name  : CH395ServerSocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : index
* Output         : None
* Return         : None
*******************************************************************************/
void CH395ServerSocketInitOpen(UINT8 index)
{
    UINT8 i;

    CH395SetSocketProtType(index,ScokInf[index].ProtoType);          /* socket Э */
    CH395SetSocketSourPort(index,ScokInf[index].SourPort);           /* socket Դ˿ */
    i = CH395OpenSocket(index);                                      /* socket  */
    mStopIfError(i);                                                 /* Ƿɹ */
    i = CH395TCPListen(index);                                       /* TCP */
    mStopIfError(i);                                                 /* Ƿɹ */
}

/*******************************************************************************
* Function Name  : CH395_FTPCtlClient
* Description    : TCP
* Input          : socketid
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_FTPCtlClient( UINT8 socketid )
{
  memset(&ScokInf[socketid],0,sizeof(ScokInf[socketid]));           /* ӦScokInfȫ*/
  memcpy(ScokInf[socketid].IPAddr,DestIPAddr,4);                    /* ĿIPַд */
  ScokInf[socketid].DesPort  = 21;                                  /* ĿĶ˿ */
  ScokInf[socketid].SourPort = 4000;                                /* Դ˿ */
  ScokInf[socketid].ProtoType= PROTO_TYPE_TCP;                      /* TCPģʽ */
  ScokInf[socketid].TcpMode  = TCP_CLIENT_MODE;                     /* TCPͻģʽ */
  ftp.SocketCtl = socketid; 
  CH395ClientSocketInitOpen( socketid );
  memset((void *)MyBuffer[socketid],'\0',sizeof(MyBuffer[socketid]));			  
}

/******************************************************************************
* Function Name  : CH395_FTPDatClient
* Description    : TCP
* Input          : socketid,port
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_FTPDatClient( UINT8 socketid,UINT16 *port )
{
  if( PortTmp<100 || PortTmp>200 ) PortTmp=100;
	PortTmp++;
    memset(&ScokInf[socketid],0,sizeof(ScokInf[socketid]));           /* ӦScokInfȫ*/
    memcpy(ScokInf[socketid].IPAddr,DestIPAddr,4);                    /* ĿIPַд */
    ScokInf[socketid].DesPort = 20;                                   /* ĿĶ˿ */
    ScokInf[socketid].SourPort = 5000+PortTmp;                        /* Դ˿ */
	*port = ScokInf[socketid].SourPort;
    ScokInf[socketid].ProtoType= PROTO_TYPE_TCP;                      /* TCPģʽ */
    ScokInf[socketid].TcpMode  = TCP_CLIENT_MODE;                     /* TCPͻģʽ */
	ftp.DatTransfer = socketid; 
	CH395ClientSocketInitOpen( socketid );
	memset((void *)MyBuffer[socketid],'\0',sizeof(MyBuffer[socketid]));			  
}

/*******************************************************************************
* Function Name  : CH395_FTPDatServer
* Description    : ʼsocket
* Input          : socketid,port
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_FTPDatServer( UINT8 socketid,UINT16 *port )
{
	if(PortTmp < 100||PortTmp > 200) PortTmp = 100;
    PortTmp++;
    memset(&ScokInf[socketid],0,sizeof(ScokInf[socketid]));           /* ӦScokInfȫ*/
    ScokInf[socketid].SourPort = 5000+ PortTmp;                       /* Դ˿ */
	*port = ScokInf[socketid].SourPort;
    ScokInf[socketid].ProtoType = PROTO_TYPE_TCP;                     /* TCPģʽ */
    ScokInf[socketid].TcpMode = TCP_SERVER_MODE;                      /* TCPģʽ */
	ftp.DatMonitor = socketid; 
	CH395ServerSocketInitOpen( socketid );
	memset((void *)MyBuffer[socketid],'\0',sizeof(MyBuffer[socketid]));			  
}

/******************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
   UINT8  sock_int_socket;
   UINT16 len;

#if CH395_DEBG
	printf("sockindex =%d\n",(UINT16)sockindex);
#endif	
  sock_int_socket = CH395GetSocketInt(sockindex);                        /* ȡsocket ж״̬ */
  if(sock_int_socket & SINT_STAT_SENBUF_FREE)                            /* ͻУԼдҪ͵ */
   {
   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                               /* ж */
   {
#if CH395_DEBG
	printf("send data success\n");
#endif
   }
   if(sock_int_socket & SINT_STAT_CONNECT)                               /* жϣTCPģʽЧ*/
   {
#if CH395_DEBG
	printf("TCP Connect\n");
#endif	
		if(sockindex == ftp.DatMonitor){
			ftp.TcpStatus = FTP_MACH_CONNECT;
			ftp.DatTransfer = sockindex;
		}
   }
   if(sock_int_socket & SINT_STAT_RECV)                                  /* ж */
   {
 
	   len = CH395GetRecvLength(sockindex);                              /* ȡǰݳ */
	   if(len){
	 	   if(len>MybufLen) len = MybufLen;
	       CH395GetRecvData(sockindex,len,MyBuffer[sockindex]);          /* ȡ */
	       ScokInf[sockindex].RemLen = len;                              /* 泤 */
		   ftp.RecDatLen = len; 
#if CH395_DEBG
	printf("len:%d\n",len);
	printf("MyBuffer:\n%s\n",MyBuffer[sockindex]);
#endif	
		  CH395_FTPProcessReceDat((char *)MyBuffer[sockindex],ftp.FileCmd,sockindex);
    	  memset((void *)MyBuffer[sockindex],'\0',sizeof(MyBuffer[sockindex]));
       }
   }
   if(sock_int_socket & SINT_STAT_DISCONNECT)                           /* ϿжϣTCPģʽЧ */
   {
#if CH395_DEBG                                                          /* жϣCH563NET_ڲὫsocketΪر*/
    printf("TCP Disconnect\n");                                         /* Ӧ´ */
#endif
		if(sockindex == ftp.DatTransfer){
			ftp.TcpStatus = 0;
			ftp.CmdDataS = FTP_MACH_DATAOVER;
		}
		CH395CloseSocket(sockindex);
   }
   if(sock_int_socket & SINT_STAT_TIM_OUT)                              /* ʱжϣTCPģʽЧ */
   {
#if CH395_DEBG                                                          /* жϣCH563NET_ڲὫsocketΪر*/
    printf("TCP Timout\n");                                             /* Ӧ´ */
#endif
       /* ʱжϱʾ//ݳʱʧܣʱʱCH395оƬڲὫ    */
       /* socketرգĳЩCH395ӣԶ˶˿δ򿪣CH395ӣ */
       /* Զ豸ܻᷢRSTǿƽӸλʱCH395Ȼʱжϡʾ */
       /* ʵӦвƼʱжϺӣԼһʱ´socket */
       /* ɡ*/         
		if(sockindex == ftp.DatTransfer){
			ftp.TcpStatus = 0;
			ftp.CmdDataS = FTP_MACH_DATAOVER;
		}
	    CH395CloseSocket(sockindex);
   }
}

/********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395GlobalInterrupt(void) 
{
    UINT16  init_status;
    UINT16 i;
    UINT8  buf[10]; 
 
    init_status = CH395CMDGetGlobIntStatus_ALL();
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        CH395CMDGetUnreachIPPT(buf);                                
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
#if  CH395_DEBG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif
        i = CH395CMDGetPHYStatus();                                  /* ȡPHY״̬ */
        if(i == PHY_DISCONN){
#if  CH395_DEBG
     printf("Ethernet Disconnect\n");                                /* PHY_DISCONNCH395ڲԶرеsocket*/
#endif
		}
    }
    if(init_status & GINT_STAT_SOCK0)
    {
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)                                
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)
    {
     CH395SocketInterrupt(2);                                        /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)                                
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }    
	if(init_status & GINT_STAT_SOCK4)
    {
     CH395SocketInterrupt(4);                                        /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)                               
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }   
	 if(init_status & GINT_STAT_SOCK6)
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)                              
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
*******************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;
    
    i = CH395CMDCheckExist(0x65);                      
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
                                                                     /* 0XFAһΪӲ߶дʱ򲻶 */
#if (CH395_OP_INTERFACE_MODE == 5)                                   
#ifdef UART_WORK_BAUDRATE
    CH395CMDSetUartBaudRate(UART_WORK_BAUDRATE);                     /* ò */   
    mDelaymS(1);
    SetMCUBaudRate();
    i = xReadCH395Data();                                            /* óɹCH395CMD_ERR_SUCCESS */
    if(i == CMD_ERR_SUCCESS)printf("Set Success\n");
#endif
#endif
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/   
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/********************************************************************************
* Function Name  : mInitSTDIO
* Description    : ڳʼ,ʹ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO( void )
{
    SCON = 0x50;
    PCON = 0x80;
    TMOD = 0x21;
    TH1 = 0xf3;                                                      /* 24MHz, 9600bps */
    TR1 = 1;
    TI = 1;
}

/********************************************************************************
* Function Name  : CH395_SocketSendData
* Description    : 
* Input          : PSend-͵
				           Len-  
				           index-socket
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_SocketSendData( char *PSend, UINT32 Len,UINT8 index  )
{
   CH395SendData(index,PSend,Len);
   printf("Send:%s",PSend);
}

/********************************************************************************
* Function Name  : CH395_FTPInitVari
* Description    : ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_FTPInitVari( )
{
	FTP *pFTP;
	UINT8 i,j;

	pFTP = &ftp;
	memset((void *)pFTP,'\0',sizeof(ftp));
	ftp.SocketCtl = 255; 
	ftp.DatMonitor = 255;
	ftp.DatTransfer = 255;
  ftp.FileCmd = FTP_CMD_LOGIN;                                       /* ִе½		*/
	memset((void *)SourIP,'\0',sizeof(SourIP));		   		
	j = 0;
  for(i=0;i<4;i++){                                                  /* ʮƵIPַתҪַʽ	*/
		if( CH395IPAddr[i]/100 ){
			SourIP[j++] = CH395IPAddr[i]/100 + '0';
			SourIP[j++] = (CH395IPAddr[i]%100)/10 + '0' ;
			SourIP[j++] = CH395IPAddr[i]%10 + '0';
		} 
		else if( CH395IPAddr[i]/10 ){
			SourIP[j++] = CH395IPAddr[i]/10 + '0';
			SourIP[j++] = CH395IPAddr[i]%10 + '0';
		} 
		else SourIP[j++] = CH395IPAddr[i]%10 + '0';
 		SourIP[j++] = ',';
	}
#if  CH395_DEBG
	printf("SourIP: %s\n",SourIP);
#endif	
}

/******************************************************************************
* Function Name  : CH395_FTPConnect
* Description    : ch395ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_FTPConnect( )
{
    UINT8 i;
 
    mDelaymS(100);                                                    /* ʱ100 */
    mInitSTDIO();  
    CH395_FTPInitVari( );                                                  
#if  CH395_DEBG
    printf("CH395FTP Demo\n");
#endif	
    CH395_PORT_INIT();

    InitCH395InfParam();                                             /* ʼCH395ر */
    i = CH395Init();                                                 /* ʼCH395оƬ */
    mStopIfError(i);
                                                                     
   while(1)
   {                                                                 /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           mDelaymS(200);                                            /* δȴ200MSٴβѯ */
       }
       else 
       {
#if  CH395_DEBG
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
#endif	
          break;
       }
   }
}
