/********************************** (C) COPYRIGHT *********************************
* File Name          : CH395.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395ʾ
**********************************************************************************/

/**********************************************************************************
CH395 TCP/IP Эӿ
MSC51 ʾʾSocket0IP RAWģʽ£Ƭյݺ󣬰λȡ
ϴMCS51@24MHZ,KEIL 4
**********************************************************************************/
/* ͷļ*/
#include <reg52.h>
#include "stdio.h"
#include "string.h"
#include "../PUB/CH395INC.H"
#include "CH395.H"

/***********************************************************************************
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3                      
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"                                           
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"                                            
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.C"
#else
#error "Please Select Correct Communication Interface "
#endif

/***********************************************************************************/
/* ļ */
#include "../PUB/CH395CMD.C"

#define     CH395_DEBUG               0
/* ñ */
UINT8 xdata MyBuffer[512];                                          /* ݻ */
struct _SOCK_INF xdata SockInf;                                      /* SocketϢ */
struct _CH395_SYS xdata CH395Inf;                                    /* CH395Ϣ */

/* CH395ض */
const UINT8 CH395IPAddr[4] = {192,168,1,10};                         /* CH395IPַ */
const UINT8 CH395GWIPAddr[4] = {192,168,1,1};                        /* CH395 */
const UINT8 CH395IPMask[4] = {255,255,255,0};                        /* CH395 */

/* socket ض*/
const UINT8  Socket0DesIP[4] = {192,168,1,100};                       /* Socket 0ĿIPַ */
const UINT8  IPRawProto = 0xE2;                                       /* IPЭ */

/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError 
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                           /* ɹ */
#if CH395_DEBUG
    printf("Error: %02X\n", (UINT16)iError);                         /* ʾ */
#endif
    while ( 1 ) 
    {
        mDelaymS(200);
        mDelaymS(200);
    }
}

/**********************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/**********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam(void)
{
    memset(&SockInf,0,sizeof(SockInf));                              /* SockInf[0]ȫ*/
    memcpy(SockInf.IPAddr,Socket0DesIP,sizeof(Socket0DesIP));        /* ĿIPַд */
    SockInf.ProtoType = PROTO_TYPE_IP_RAW;                           /* IP RAWģʽ */
}

/**********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInitOpen(void)
{
    UINT8 i;

    /* socket 0ΪIP RAWģʽ */
    CH395SetSocketDesIP(0,SockInf.IPAddr);                           /* socket 0ĿIPַ */         
    CH395SetSocketProtType(0,SockInf.ProtoType);                     /* socket 0Э */
    CH395SetSocketIPRAWProto(0,IPRawProto);                          /* Эֶ */
    i = CH395OpenSocket(0);                                          /* socket 0 */
    mStopIfError(i);                                                 /* Ƿɹ */
}

/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
   UINT8  sock_int_socket;
   UINT16 len;
   UINT16 tmp;

   sock_int_socket = CH395GetSocketInt(sockindex);                   /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {

   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
       len = CH395GetRecvLength(sockindex);                          /* ȡǰݳ */
#if CH395_DEBUG
       printf("receive len = %d\n",len);
#endif

       if(len == 0)return;
       if(len > 512)len = 512;                                       /* MyBufferΪ512 */
       CH395GetRecvData(sockindex,len,MyBuffer);                     /* ȡ */
       for(tmp =0; tmp < len; tmp++)                                 /* ݰλȡ */
       {
          MyBuffer[tmp] = ~MyBuffer[tmp];
       }
       CH395SendData(sockindex,MyBuffer,len);

   }
   /*
   **ϿжϺͳʱжʱCH395ĬڲرգûҪԼرոSocketóɲرSocketҪ
   **SOCK_CTRL_FLAG_SOCKET_CLOSE־λĬΪ0ñ־Ϊ1CH395ڲSocketйرմûжϺͳʱжʱ
   **CH395CloseSocketSocketйرգرSocketһֱΪӵ״̬ʵѾϿͲȥˡ
   */
   if(sock_int_socket & SINT_STAT_CONNECT)                          /* жϣTCPģʽЧ*/
   {
   }
   if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
   {
   }
   if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱжϣTCPģʽЧ */
   {
   }
}

/**********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395GlobalInterrupt(void)
{
   UINT16  init_status;

   UINT8  buf[10]; 
 
    init_status = CH395CMDGetGlobIntStatus_ALL();
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        CH395CMDGetUnreachIPPT(buf);                                
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
#if CH395_DEBUG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif
    }
    if(init_status & GINT_STAT_SOCK0)
    {
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)                                
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)                                
    {
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)                                
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
        CH395SocketInterrupt(4);                                     /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)                                
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)                                
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)                                
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/**********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;
    
    i = CH395CMDCheckExist(0x65);                      
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
                                                                     /* 0XFAһΪӲ߶дʱ򲻶 */
#if (CH395_OP_INTERFACE_MODE == 5)                                   
#ifdef UART_WORK_BAUDRATE
    CH395CMDSetUartBaudRate(UART_WORK_BAUDRATE);                     /* ò */   
    mDelaymS(1);
    SetMCUBaudRate();
#endif
#endif
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/ 
    mDelaymS(10);  
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/**********************************************************************************
* Function Name  : mInitSTDIO
* Description    : ڳʼ,ʹ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void mInitSTDIO( void )
{
    SCON = 0x50;
    PCON = 0x80;
    TMOD = 0x21;
    TH1 = 0xf3;                                                      /* 24MHz, 9600bps */
    TR1 = 1;
    TI = 1;
}

/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
int main(void)
{
    UINT8 i;
 
    mDelaymS(100);
    mInitSTDIO();                                                    /* ʱ100 */
#if CH395_DEBUG
    printf("CH395EVT Test Demo\n");
#endif
    CH395_PORT_INIT();

    InitCH395InfParam();                                             /* ʼCH395ر */
    i = CH395Init();                                                 /* ʼCH395оƬ */
    mStopIfError(i);
                                                                     
   while(1)
   {                                                                 /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           mDelaymS(200);                                            /* δȴ200MSٴβѯ */
       }
       else 
       {
#if CH395_DEBUG
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
#endif
           break;
       }
   }
   InitSocketParam();                                                /* ʼsocketر */
   CH395SocketInitOpen();
   while(1)
   {
       if(CH395_INT_WIRE == 0)CH395GlobalInterrupt();
   }
}

