/********************************** (C) COPYRIGHT *********************************
* File Name          : CH395.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395ʾ
**********************************************************************************/

/**********************************************************************************
CH395 TCP/IP Эӿ
MSC51 ʾʾSocket0TCP Serverģʽ£Ƭյݺ󣬰λȡ
ϴ˹ܽ0x44汾֧֣ϵ֧䣺tech@wch.cn
MCS51@24MHZ,KEIL 3.51
**********************************************************************************/
/* ͷļ*/
#include <reg52.h>
#include "stdio.h"
#include "string.h"
#include "../PUB/CH395INC.H"
#include "CH395.H"

/***********************************************************************************
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3                      
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"                                           
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"                                            
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.C"
#else
#error "Please Select Correct Communication Interface "
#endif

/**********************************************************************************/
/* ļ */
#include "../PUB/CH395CMD.C"

#define  CH395_DEBUG                1

#define  SocketNum                  8                                /*TCP SERVER ֵ֧Socket(SocketNum -1)*/
#define  TcpMss                     536                              /*TCPMSS*/
/* ñ */
UINT8 xdata MyBuffer[SocketNum-1][TcpMss*2];                         /* ݻ */
struct _SOCK_INF xdata SockInf;                                      /* SocketϢ */
struct _CH395_SYS xdata CH395Inf;                                    /* CH395Ϣ */

/* CH395ض */
const UINT8 CH395IPAddr[4] = {192,168,1,10};                         /* CH395IPַ */
const UINT8 CH395GWIPAddr[4] = {192,168,1,1};                        /* CH395 */
const UINT8 CH395IPMask[4] = {255,255,255,0};                        /* CH395 */

/* socket ض*/
const UINT16 Socket0SourPort = 5000;                                 /* Socket 0Դ˿ */

/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                           /* ɹ */
#if CH395_DEBUG
    printf("Error: %02X\n", (UINT16)iError);                         /* ʾ */
#endif
    while ( 1 ) 
    {
        mDelaymS(200);
        mDelaymS(200);
    }
}

/**********************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/**********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam(void)
{
    memset(&SockInf,0,sizeof(SockInf));                              /* SockInf[0]ȫ*/
    SockInf.SourPort = Socket0SourPort;                              /* Դ˿ */
    SockInf.ProtoType = PROTO_TYPE_TCP;                              /* TCPģʽ */
    SockInf.TcpMode = TCP_SERVER_MODE;
}

/**********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInitOpen(void)
{
    UINT8 i;
    /* socket 0ΪTCP ģʽ */
    CH395SetSocketProtType(0,SockInf.ProtoType);                       /* socket 0Э */
    CH395SetSocketSourPort(0,SockInf.SourPort);                        /* socket 0Դ˿ */
    i = CH395OpenSocket(0);                                            /* socket 0 */
    mStopIfError(i);                                                   /* Ƿɹ */
    i = CH395TCPListen(0);                                             /* TCP */
    mStopIfError(i); 
  
  for(i=1;i<SocketNum;i++)
  {
      CH395SetSocketProtType(i,SockInf.ProtoType);                     /* socket 0Э */
      CH395SetSocketSourPort(i,SockInf.SourPort);                      /* socket 0Դ˿ */
  }                                                
}

/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
   UINT8  sock_int_socket,i;
   UINT16 len;
   UINT16 tmp;
   UINT8 idata buf[10];

   sock_int_socket = CH395GetSocketInt(sockindex);                   /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {
   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
       len = CH395GetRecvLength(sockindex);                          /* ȡǰݳ */
#if CH395_DEBUG
       printf("receive len = %d\n",len);
#endif
       if(len == 0)return;
       if(len > 100)len = 100;                                       /* MyBufferΪ512*/
       CH395GetRecvData(sockindex,len,MyBuffer[sockindex]);          /* ȡ */
       CH395SendData(sockindex,MyBuffer[sockindex],len);
   }
   if(sock_int_socket & SINT_STAT_CONNECT)                           /* жϣTCPģʽЧ*/
   {
#if CH395_DEBUG
       printf("Tcp Connect\n");
#endif
       if(SockInf.TcpMode == TCP_SERVER_MODE)                       /* socket ΪģʽûԻȡԶ˵IPͶ˿*/
       {
           CH395CMDGetRemoteIPP(sockindex,buf);
           tmp = (UINT16)(buf[5]<<8) + buf[4];
#if CH395_DEBUG
           printf("IP address = %d.%d.%d.%d\n",(UINT16)buf[0],(UINT16)buf[1],(UINT16)buf[2],(UINT16)buf[3]);    
           printf("Port = %d\n",tmp);    
#endif
       }
   }
   /*
   **ϿжϺͳʱжʱCH395ĬڲرգûҪԼرոSocketóɲرSocketҪ
   **SOCK_CTRL_FLAG_SOCKET_CLOSE־λĬΪ0ñ־Ϊ1CH395ڲSocketйرմûжϺͳʱжʱ
   **CH395CloseSocketSocketйرգرSocketһֱΪӵ״̬ʵѾϿͲȥˡ
   */
   /*SOCK_CTRL_FLAG_SOCKET_CLOSEλжҪرSocketٽλҪCH395CloseSocketCH395ڲѾرա*/
   if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
   {
	   
	   i = CH395CloseSocket(sockindex);                             
		mStopIfError(i);
	   mDelaymS(2);
	   i = CH395OpenSocket(sockindex);
	   mStopIfError(i);
   }
	if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱжϣTCPģʽЧ */
	{
		i = CH395CloseSocket(sockindex);                             
		mStopIfError(i);
		mDelaymS(2);
		i = CH395OpenSocket(sockindex);
		mStopIfError(i);
	}
}

/**********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395GlobalInterrupt(void)
{
   UINT16  init_status;
   UINT8  buf[10]; 
 
    init_status = CH395CMDGetGlobIntStatus_ALL();
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        CH395CMDGetUnreachIPPT(buf);                                
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
#if CH395_DEBUG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif
    }
    if(init_status & GINT_STAT_SOCK0)
    {
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)                                
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)                                
    {
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)                                
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
        CH395SocketInterrupt(4);                                     /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)                                
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)                               
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)                               
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/**********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;
    
    i = CH395CMDCheckExist(0x65);                      
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
#if (CH395_OP_INTERFACE_MODE == 5)                                   
#ifdef UART_WORK_BAUDRATE
    CH395CMDSetUartBaudRate(UART_WORK_BAUDRATE);                     /* ò */   
    mDelaymS(1);
    SetMCUBaudRate();
#endif
#endif
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/   
	/*
	**SOCK_CTRL_FLAG_SOCKET_CLOSEñ־λ1ĬΪ0CH395ڲرSocketһЩ쳣ж磺ʱϿʱҪйرSocket
	**رգSocketһֱռãͷš
	*/
    CH395SetStartPara(FUN_PARA_FLAG_TCP_SERVER|SOCK_CTRL_FLAG_SOCKET_CLOSE);                     /*TCP SERVERֶ֧ʱʼ*/
    mDelaymS(100);
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/*********************************************************************************
* Function Name  : mInitSTDIO
* Description    : ڳʼ,ʹ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void mInitSTDIO( void )
{
    SCON = 0x50;
    PCON = 0x80;
    TMOD = 0x21;
    TH1 = 0xf3;                                                      /* 24MHz, 9600bps */
    TR1 = 1;
    TI = 1;
}

/*********************************************************************************
* Function Name  : Socket_R_S_Buf_Modify
* Description    : Socketշ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void Socket_R_S_Buf_Modify(void )
{

   CH395SetSocketRecvBuf(0,0,4);                                     /* Socket 0 ջ4*512 = 2Kͻ2*512 = 1K*/
   CH395SetSocketSendBuf(0,4,2);  
  
   CH395SetSocketRecvBuf(1,6,4);                                     /* Socket 1 */
   CH395SetSocketSendBuf(1,10,2);  
  
   CH395SetSocketRecvBuf(2,12,4);                                    /* Socket 2 */
   CH395SetSocketSendBuf(2,16,2);  
  
   CH395SetSocketRecvBuf(3,18,4);                                    /* Socket 3 */
   CH395SetSocketSendBuf(3,22,2);  
  
   CH395SetSocketRecvBuf(4,24,4);                                    /* Socket 4 */
   CH395SetSocketSendBuf(4,28,2);  
  
   CH395SetSocketRecvBuf(5,30,4);                                    /* Socket 5 */
   CH395SetSocketSendBuf(5,34,2);
  
   CH395SetSocketRecvBuf(6,36,4);                                    /* Socket 6 */
   CH395SetSocketSendBuf(6,40,2);  
  
   CH395SetSocketRecvBuf(7,42,4);                                    /* Socket 7 */
   CH395SetSocketSendBuf(7,46,2);  

}
/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
int main(void)
{
    UINT8 i;
 
    mDelaymS(100);
    mInitSTDIO();                                                    /* ʱ100 */
#if CH395_DEBUG
    printf("CH395EVT Test Demo\n");
#endif
    CH395_PORT_INIT();
 
    i =   CH395CMDGetVer();
    if(i < 0x44)                                                     /* TCP SERVERģʽ0X44ϰ汾֧֣0x44°汾TCP SERVERֻ֧һ */
    {
#if CH395_DEBUG
     printf("Error: Not Support!\n");                                /* ʾ */
#endif
     while ( 1 ) 
     {
        mDelaymS(200);
        mDelaymS(200);
     }   
    }
    InitCH395InfParam();                                             /* ʼCH395ر */
    i = CH395Init();                                                 /* ʼCH395оƬ */
    mStopIfError(i);
 
    Socket_R_S_Buf_Modify();                                         /* Socketͺͽջ*/
    CH395SetTCPMss(TcpMss);                                          /* TCPMSS*/
                                                                    
    while(1)
    {                                                                /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           mDelaymS(200);                                            /* δȴ200MSٴβѯ */
       }
       else 
       {
#if CH395_DEBUG
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
#endif
           break;
       }
    }
    InitSocketParam();                                                /* ʼsocketر */
    CH395SocketInitOpen();
    while(1)
    {
       if(CH395_INT_WIRE == 0)CH395GlobalInterrupt();
    }
}

