/********************************** (C) COPYRIGHT *********************************
* File Name          : CH395.c
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395                      
**********************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\SRC\CH563SFR.H"
#include "..\SRC\SYSFREQ.H"
#include "..\..\PUB\CH395INC.H"
#include "CH395.H"
#include "..\..\PUB\ch395cmd.h"

struct  _SOCK_INF  SockInf;
struct  _CH395_SYS  CH395Inf;  
   
/*******************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                           /* ɹ */
    printf("Error: %02X\n", (UINT16)iError);                         /* ʾ */
    while ( 1 ) 
    {
        mDelaymS(200);
        mDelaymS(200);
    }
}

/*******************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void InitSocketParam(void)
{
    memset(&SockInf,0,sizeof(SockInf));                              /* SockInf[0]ȫ*/
    SockInf.SourPort = Socket0SourPort;                              /* Դ˿ */
    SockInf.ProtoType = PROTO_TYPE_TCP;                              /* TCPģʽ */
    SockInf.TcpMode = TCP_SERVER_MODE;
}

/********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SocketInitOpen(void)
{
    UINT8 i;
    /* socket 0ΪTCP ģʽ */
    CH395SetSocketDesIP(0,SockInf.IPAddr);                           /* socket 0ĿIPַ */         
    CH395SetSocketProtType(0,SockInf.ProtoType);                     /* socket 0Э */
    CH395SetSocketDesPort(0,SockInf.DesPort);                        /* socket 0ĿĶ˿ */
    CH395SetSocketSourPort(0,SockInf.SourPort);                      /* socket 0Դ˿ */
    i = CH395OpenSocket(0);                                          /* socket 0 */
    mStopIfError(i);                                                 /* Ƿɹ */
    i = CH395TCPListen(0);                                           /* TCP */
    mStopIfError(i);                                                 /* Ƿɹ */
}

/*******************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex
* Output         : None
* Return         : None
*******************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
   UINT8  sock_int_socket;
   UINT8  buf[10],s;
   memcpy (lastip,CH395IPAddr,4);
   lastport = Socket0SourPort ;
   sock_int_socket = CH395GetSocketInt(sockindex);                   /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {
      printf("SINT_STAT_SENBUF_FREE\n");   
      if(SockInf.SendLen >= SockInf.RemLen)
       {
        SockInf.RemLen = 0;                                          /* Ѿ */
        CH395TCPDisconnect(0);
       }
     else
       {
        SockInf.pSend += SockInf.SendLen;                           /* Էָƫ */
        SockInf.RemLen -= SockInf.SendLen;                          /* ʣ೤ */
        if(SockInf.RemLen > 2048)SockInf.SendLen = 2048;            /* 㱾οԷ͵ݳ */
        else SockInf.SendLen = SockInf.RemLen;    
        CH395SendData(sockindex,SockInf.pSend,SockInf.SendLen);     /*  */
       }
   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
       printf("SINT_STAT_RECV\n");
       len = CH395GetRecvLength(sockindex);                          /* ȡǰݳ */
       if(len == 0)return;
       CH395GetRecvData(sockindex,len,RecvBuffer);                   /* ȡ */
       flag  |= RECVDATA;
   }
   if(sock_int_socket & SINT_STAT_CONNECT)                           /* жϣTCPģʽЧ*/
   {
      printf("Tcp Connect\n");
      if(SockInf.TcpMode == TCP_SERVER_MODE)                         /* socket ΪģʽûԻȡԶ˵IPͶ˿*/
      {
       CH395CMDGetRemoteIPP(sockindex,buf);
       printf("IP address = %d.%d.%d.%d\n",(UINT16)buf[0],(UINT16)buf[1],(UINT16)buf[2],(UINT16)buf[3]);        
      }
   }
   if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
   {
      printf("SINT_STAT_DISCONNECT\n");
      s = CH395OpenSocket(0);                                        /* socket 0 */
      mStopIfError(s);                                               /* Ƿɹ */
      s = CH395TCPListen(0);                                         /* TCP */
      mStopIfError(s);  

   }
   if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱжϣTCPģʽЧ */
   {
       printf("Tcp Time out\n");
   }
}

/*******************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395GlobalInterrupt(void)
{
    UINT16 init_status;
    UINT8  buf[10]; 
    init_status = CH395CMDGetGlobIntStatus_ALL();
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        printf("Init status : GINT_STAT_UNREACH\n");                 /* UDPģʽ¿ܻɴж */
        CH395CMDGetUnreachIPPT(buf);                                
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
    }
    if(init_status & GINT_STAT_SOCK0)
    {
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)                                
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)                                
    {
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)                                
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
        CH395SocketInterrupt(4);                                     /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)                                
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)                                
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)                                
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
*******************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;
    i = CH395CMDCheckExist(0x65); 
    printf("CH395CMDCheckExist = %2x\n",(UINT16)i);                     
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/   
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    printf("CH395CMDInitCH395 = %2x\n",(UINT16)i); 
    return i;
}
